import { TypeRegistry } from "../types/TypeRegistry";
export interface Watchable {
    _addWatcher(cb: WatcherOptions): void;
    _removeWatcher(cb: WatcherOptions): void;
    _typeRegistry: TypeRegistry;
}
/**
 * Container for change function that gets called when values in a DeltaWatch are modified
 */
export declare class WatcherOptions {
    private readonly _change;
    constructor(change: Function);
    readonly change: Function;
}
export declare class DeltaWatch<T> implements Watchable {
    static watch(watchable: Watchable | any, cb: Function): void;
    static unwatch(watchable: Watchable | any, cb: Function): void;
    private readonly _watcher;
    private readonly _mutator;
    private _dataValue;
    private readonly _rootTypeRegistry;
    constructor(data: T);
    readonly Watcher: T;
    readonly Accessor: T;
    Mutator: T;
    _addWatcher(cb: WatcherOptions): void;
    _removeWatcher(cb: WatcherOptions): void;
    readonly _typeRegistry: TypeRegistry;
    readonly _data: {
        [key: string]: any;
    };
}
