"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function makeObjectAccessorHandler(typeRegistry) {
    return {
        get: function (obj, prop) {
            if (prop in obj) {
                var val = obj[prop];
                var makeAccessor = typeRegistry.getMakeAccessorForValue(val);
                var proxy = makeAccessor ? makeAccessor(val, typeRegistry) : null;
                return proxy === null ? val : proxy;
            }
        },
        set: function () {
            throw Error("Cannot set a value on the Accessor object.");
        }
    };
}
function makeObjectAccessor(obj, typeRegistry) {
    return new Proxy(obj, makeObjectAccessorHandler(typeRegistry));
}
exports.makeObjectAccessor = makeObjectAccessor;
//# sourceMappingURL=ObjectAccessor.js.map