import { DeltaWatch, Watchable, WatcherOptions } from "./DeltaWatch";
import { TypeRegistry } from "../types/TypeRegistry";
import { PropKey } from "../types/utils";
export declare function MakeObjectWatcher(parent: DeltaWatch<any> | ObjectWatcher, parentKey?: PropKey, skipChildren?: boolean): ObjectWatcher;
export declare class ObjectWatcher implements Watchable {
    static getMutator(watcher: ObjectWatcher, field: PropKey): any;
    static getFieldWatcher(watcher: ObjectWatcher, field: PropKey): ObjectWatcher;
    readonly _parent: DeltaWatch<any> | ObjectWatcher;
    readonly _parentKey: PropKey;
    private _watcherOptions;
    private _lastValue;
    private readonly _childProperties;
    private readonly _mutators;
    constructor(parent: DeltaWatch<any> | ObjectWatcher, parentKey?: PropKey, skipChildren?: boolean);
    _addWatcher(options: WatcherOptions): void;
    _removeWatcher(options: WatcherOptions): void;
    _makeMutator(field: PropKey): void;
    _makeProperty(field: PropKey): void;
    _notifySubscribers(notifyParent?: boolean, notifyChildren?: boolean, fromChangedChild?: boolean): boolean;
    _fieldData(field: PropKey): any;
    readonly _data: any;
    readonly _subscribers: WatcherOptions[];
    readonly _properties: {
        [key: string]: ObjectWatcher;
    };
    readonly _typeRegistry: TypeRegistry;
}
