"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
exports.arrayMutatorMethods = [
    'push',
    'unshift',
    'pop',
    'shift',
    'splice',
    'fill',
    'sort',
    'copyWithin',
    'reverse'
];
function makeGetOnlyArrayProxy(ary) {
    return new Proxy(ary, utils_1.makeAccessorHandler(exports.arrayMutatorMethods));
}
exports.makeGetOnlyArrayProxy = makeGetOnlyArrayProxy;
function makeArrayMutator(watcher) {
    var internals = {
        watcher: watcher,
        type: "Array"
    };
    return new Proxy({}, utils_1.makeMutationHandler(internals, exports.arrayMutatorMethods, function (prop) {
        var val = prop;
        if (typeof prop === 'string') {
            try {
                val = parseInt(prop);
            }
            catch (e) {
                return false;
            }
        }
        if (typeof val === 'number') {
            return true;
        }
    }));
}
exports.makeArrayMutator = makeArrayMutator;
exports.ArrayTypeInfo = {
    makeMutator: makeArrayMutator,
    makeAccessor: makeGetOnlyArrayProxy,
    handlesValue: function (value) {
        return Array.isArray(value);
    },
    type: "Array"
};
//# sourceMappingURL=ArrayType.js.map