"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var dateMutatorMethods = [
    'setDate',
    'setFullYear',
    'setHours',
    'setMilliseconds',
    'setMinutes',
    'setMonth',
    'setSeconds',
    'setTime',
    'setUTCDate',
    'setUTCFullYear',
    'setUTCHours',
    'setUTCMilliseconds',
    'setUTCMinutes',
    'setUTCMonth',
    'setUTCSeconds',
    'setUTCTime',
];
function makeDateMutator(watcher) {
    var internals = {
        watcher: watcher,
        type: "Date"
    };
    return new Proxy({}, utils_1.makeMutationHandler(internals, dateMutatorMethods));
}
exports.makeDateMutator = makeDateMutator;
function makeGetOnlyDateProxy(date) {
    return new Proxy(date, utils_1.makeAccessorHandler(dateMutatorMethods));
}
exports.makeGetOnlyDateProxy = makeGetOnlyDateProxy;
exports.DateTypeInfo = {
    makeMutator: makeDateMutator,
    makeAccessor: makeGetOnlyDateProxy,
    handlesValue: function (value) {
        return value instanceof Date;
    },
    type: "Date"
};
//# sourceMappingURL=DateType.js.map